main = {
	{x=0,y=0,w=400,h=100,action={"null"}},
	{x=128,y=22,w=7,h=14,action={"1"}},
	{x=140,y=22,w=7,h=14,action={"2"}},
	{x=160,y=22,w=20,h=14,action={"3"}},
	{x=330,y=78,w=50,h=14,action={"alarm"}},
}

function ysort (a,b)
	return (a[3][3]*100)+a[3][2]+(a[3][1]/100)<(b[3][3]*100)+b[3][2]+(b[3][1]/100)
end

function love.load()
	require "ow_rope"
	
	font14 = love.graphics.newFont("pixelfont.ttf",14)
	debugfont = love.graphics.newFont("pixelfont.ttf",11)
	love.graphics.setFont(font14)
	
	bubble = love.graphics.newImage("speechbox.png")
	pointer = love.graphics.newImage("pointer.png")
	timee = love.graphics.newImage("monkoferispixel.png")
	
	alarmsound = love.audio.newSource("alarm.mp3","stream")
	
	ropeLoad("obscureworlds/timegod","settings.lua")
	
	tempdate = os.date("*t")
	state = "load"
	dateabbreviation = null
	for i,v in ipairs(events) do
		local temp = true
		if v[3][3] < tempdate.year then
			temp = false
		elseif v[3][2] < tempdate.month and tempdate.year == v[3][3] then
			temp = false
		elseif v[3][1] < tempdate.day and tempdate.year == v[3][3] and tempdate.month == v[3][2] then
			temp = false
		end
		if temp == false then
			if v[2] == "repeat" then
				v[3][3] = tempdate.year
			else
				table.remove(events,i)
			end
		end
	end
	table.sort(events,ysort)
	state = "main"
	debug = false
	typedinput = false
	numberinput = false
	typed = {}
	newevent = {name = " ", state = " ", pos = {00,00,0000}}
	alarm = {state = false, length = 60, inter = 15, nextalarm = "null", isinter = false}
	tempdate = null
	tempdate = "null"
	tdt = 0
	es = 1
end

function alarmcheck()
	output = false
	if alarm.nextalarm-os.time() <= 0 then
		output = true
	end
	return output
end

function love.update(dt)
	mX = love.mouse.getX()
	mY = love.mouse.getY()
	
	if alarm.state then
		if alarmcheck() then
			if isinter then
				alarm.nextalarm = os.time() + (alarm.length*60)
				alarm.isinter = false
				love.audio.play(alarmsound)
				if not love.graphics.hasFocus() then
					love.event.push("focus")
				end
			else
				alarm.nextalarm = os.time() + (alarm.inter*60)
				alarm.isinter = true
				love.audio.play(alarmsound)
				if not love.graphics.hasFocus() then
					love.event.push("focus")
				end
			end
		end
	end
	
	keydown()
end

function love.draw()
	
	local date = os.date("%d")
	if date ~= 1 or date ~= 2 or date ~= 3 then
		dateabbreviation = "th"
	elseif date == 1 then
		dateabbreviation = "st"
	elseif date == 2 then
		dateabbreviation = "nd"
	elseif date == 3 then
		dateabbreviation = "rd"
	end
	
	love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
	love.graphics.draw(timee,56,5,0,1,1,(timee:getWidth()/2))
	love.graphics.draw(bubble,120,5)
	love.graphics.draw(pointer,110,50)
	
	
	love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
	if alarm.state and state == "alarm" then
		if alarm.isinter then
			love.graphics.printf("Next alarm in: "..alarm.nextalarm-os.time()..". INTERVAL.",130,8,250,"left")
		else
			love.graphics.printf("Next alarm in: "..alarm.nextalarm-os.time(),130,8,250,"left")
		end
	elseif state == "main" then
		if es == 1 then
			love.graphics.printf("Next event: "..events[es][1].." on "..events[es][3][1].."/"..events[es][3][2].."/"..events[es][3][3],130,8,250,"left")
		else
			love.graphics.printf("Event "..es.." : "..events[es][1].." on "..events[es][3][1].."/"..events[es][3][2].."/"..events[es][3][3],130,8,250,"left")
		end
		love.graphics.print("<  >    [N]",130,22)
	elseif state == "eventinput_title" then
		love.graphics.printf("Type title: "..newevent.name..". [N] to finish",130,8,250,"left")
		love.graphics.print("        [N]",130,22)
	elseif state == "eventinput_state" then
		love.graphics.printf("Repeat event = <, single use = >.",130,8,250,"left")
		love.graphics.print("<  >",130,22)
	elseif state == "eventinput_date" then
		if newevent.pos[1] / 10 < 1 and newevent.pos[2] / 10 < 1 then
			love.graphics.printf("Type date DD/MM/YYYY: 0"..newevent.pos[1].."/0"..newevent.pos[2].."/"..newevent.pos[3]..".",130,8,250,"left")
		elseif newevent.pos[1] / 10 < 1 then
			love.graphics.printf("Type date DD/MM/YYYY: 0"..newevent.pos[1].."/"..newevent.pos[2].."/"..newevent.pos[3]..".",130,8,250,"left")
		elseif newevent.pos[2] / 10 < 1 then
			love.graphics.printf("Type date DD/MM/YYYY: "..newevent.pos[1].."/0"..newevent.pos[2].."/"..newevent.pos[3]..".",130,8,250,"left")
		else
			love.graphics.printf("Type date DD/MM/YYYY: "..newevent.pos[1].."/"..newevent.pos[2].."/"..newevent.pos[3]..".",130,8,250,"left")
		end
		love.graphics.print("        [N]",130,22)
	end
	
	
	
	love.graphics.print(os.date("%I:%M:%S %p,"),130,50)
	love.graphics.print(os.date("Today is %A the %d"..dateabbreviation.." of %B %Y."),130,64)
	love.graphics.print(os.date("%x"),130,78)
	if alarm.state then
		love.graphics.print("Alarm: ON",330,78)
	else
		love.graphics.print("Alarm: OFF",330,78)
	end
	
	if debug then
		if main ~= null then
			if #main > 1 then
				love.graphics.setColor(200,200,200,100)
				for i = 2,#main do
					love.graphics.rectangle("fill",main[i].x,main[i].y,main[i].w,main[i].h)
				end
				love.graphics.setColor(255,255,255,255)
			end
		end
	
		love.graphics.setFont(debugfont)
		love.graphics.setColor(0,0,0,100)
		love.graphics.rectangle("fill",mX+5,mY+5,150,25)
		love.graphics.setColor(255,255,255,255)
		love.graphics.print("Mpos="..love.mouse.getX().." : "..love.mouse.getY(),mX+10,mY+5)
		love.graphics.print("fps="..love.timer.getFPS(),mX+10,mY+17)
		love.graphics.setFont(font14)
	end
end

-- click area detection functions for menu code

-- BOX COLLISIONS

-- Collision detection function.
-- Checks if box1 and box2 overlap.
-- w and h mean width and height.
function checkCollision(box1x, box1y, box1w, box1h, box2x, box2y, box2w, box2h)
    if box1x > box2x + box2w - 1 or -- Is box1 on the right side of box2?
       box1y > box2y + box2h - 1 or -- Is box1 under box2?
       box2x > box1x + box1w - 1 or -- Is box2 on the right side of box1?
       box2y > box1y + box1h - 1    -- Is b2 under b1?
    then
        return false                -- No collision. Yay!
    else
        return true                 -- Yes collision. Ouch!
    end
end

function nearestMenu(x,y)
	current = nearestestui(x,y,main)
	return current
end

function nearestestui(x,y,table)
	for i,v in ipairs(table) do
		if checkCollision(x,y,1,1,v.x,v.y,v.w,v.h) == true then
			id = i
		end
	end
	return id
end

function love.mousepressed(x,y,button)
	if button == "l" then
		mouseAction(x,y,1)
	end
end

function mouseAction(x,y,act)
	----MENU
	
	--NULL INPUT
	--stops it from crashing if theres nothing at click
	if main[nearestMenu(x,y)].action[1] == "null" then
	elseif main[nearestMenu(x,y)].action[1] == "1" then
		if state == "main" then
			if es == 1 then
				es = #events
			else
				es = es - 1
			end
		elseif state == "eventinput_state" then
			newevent.state = "repeat"
			state = "eventinput_date"
			numberinput = true
		end
	elseif main[nearestMenu(x,y)].action[1] == "2" then
		if state == "main" then
			if es == #events then
				es = 1
			else
				es = es + 1 
			end
		elseif state == "eventinput_state" then
			newevent.state = "non-repeat"
			state = "eventinput_date"
			numberinput = true
		end
	elseif main[nearestMenu(x,y)].action[1] == "3" then
		if state == "main" then
			state = "eventinput_title"
			typedinput = true
		elseif state == "eventinput_title" and newevent.name ~= " " then
			state = "eventinput_state"
			typedinput = false
		elseif state == "eventinput_date" then
			table.insert(events,{newevent.name,newevent.state,{newevent.pos[1],newevent.pos[2],newevent.pos[3]}})
			newevent = {name = " ", state = " ", pos = {00,00,0000}}
			tdt = 0
			numberinput = false
			typed = {}
			tempdate = os.date("*t")
			for i,v in ipairs(events) do
				local temp = true
				if v[3][3] < tempdate.year then
					temp = false
				elseif v[3][2] < tempdate.month and tempdate.year == v[3][3] then
					temp = false
				elseif v[3][1] < tempdate.day and tempdate.year == v[3][3] and tempdate.month == v[3][2] then
					temp = false
				end
				if temp == false then
					if v[2] == "repeat" then
						v[3][3] = tempdate.year
					else
						table.remove(events,i)
					end
				end
			end
			tempdate = null
			tempdate = "null"
			eventsoutput = "events={"
			for i,v in ipairs(events) do
				eventsoutput = eventsoutput.."{"..'"'..v[1]..'"'..","..'"'..v[2]..'"'..","..ropeBurn(v[3]).."},"
			end
			eventsoutput = eventsoutput.."}"
			love.filesystem.write("settings.lua","settings="..ropeBurn(settings)..eventsoutput)
			table.sort(events,ysort)
			state = "main"
		end
	elseif main[nearestMenu(x,y)].action[1] == "alarm" then
		if alarm.state then
			alarm.state = false
			state = "main"
			alarm.nextalarm = "null"
			alarm.isinter = false
		else
			alarm.state = true
			state = "alarm"
			alarm.nextalarm = os.time() + (alarm.length*60)
		end
	end
end

-- function that checks if a key is down every game tickyeah
shifton = null
function keydown()
	if love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift") then
		shifton = true
	else
		shifton = false
	end
end

function love.keypressed(key)
	if key == "f1" then
		if debug then
			debug = false
		else
			debug = true
		end
	elseif typedinput then
		keyAction("typedinput",key)
	elseif numberinput then
		keyAction("numberinput",key)
	end
end

function typedinputcheck(item)
	local temp = false
	local possibleinputs = {" ","1","2","3","4","5","6","7","8","9","0","q","w","e","r","t","y","u","i","o","p","a","s","d","f","g","h","j","k","l","z","x","c","v","b","n","m"}
	
	for i,v in ipairs(possibleinputs) do
		if item == v then
			temp = true
		end
	end
	
	return temp
end

function numbercheckandreturn(item)
	local output = false
	local possibleinputs = {"1","2","3","4","5","6","7","8","9","0"}
	
	for i,v in ipairs(possibleinputs) do
		if item == v then
			output = i
		end
	end
	
	if output == 10 then
		output = 0
	end
	
	return output
end



--SUPERFUNCTION
--controls all of the actions from keyboard inputs from both
--keypressed and keydown
--x and y not just used for x and y positions
--but also for x and y arguments or information for ease of customisation of this table
function keyAction(action,x,y)
	if action == "typedinput" then
		if x == "backspace" or x == "delete" then
			table.remove(typed)
		else
			if font14:getWidth(table.concat(typed)) <= 90 and typedinputcheck(x) then
				if shifton then
					table.insert(typed,string.upper(x))
				else
					table.insert(typed,x)
				end
			end
		end
		newevent.name = table.concat(typed)
	end
	if action == "numberinput" then
		if x == "backspace" or x == "delete" then
			tempdate = "null"
			newevent.pos = {00,00,0000}
			tdt = 0
		elseif numbercheckandreturn(x) ~= false then
			if tdt < 2 then
				if tempdate == "null" then
					tempdate = numbercheckandreturn(x)
					newevent.pos[1] = tempdate
					tdt = tdt + 1
				else
					if tempdate ~= 0 then
						tempdate = tempdate*10
						tempdate = tempdate + numbercheckandreturn(x)
						newevent.pos[1] = tempdate
						tempdate = "null"
						tdt = tdt + 1
					elseif tempdate == 0 and numbercheckandreturn(x) ~= 0 then
						tempdate = numbercheckandreturn(x)
						newevent.pos[1] = tempdate
						tempdate = "null"
						tdt = tdt + 1
					end
				end
			elseif tdt > 1 and tdt < 4  then
				if tempdate == "null" then
					tempdate = numbercheckandreturn(x)
					newevent.pos[2] = tempdate
					tdt = tdt + 1
				else
					if tempdate ~= 0 then
						tempdate = tempdate*10
						tempdate = tempdate + numbercheckandreturn(x)
						newevent.pos[2] = tempdate
						tempdate = "null"
						tdt = tdt + 1
					elseif tempdate == 0 and numbercheckandreturn(x) ~= 0 then
						tempdate = numbercheckandreturn(x)
						newevent.pos[2] = tempdate
						tempdate = "null"
						tdt = tdt + 1
					end
				end
			elseif tdt > 3 and tdt < 8 then
				if tempdate == "null" and numbercheckandreturn(x) ~= 0 then
					tempdate = numbercheckandreturn(x)
					tdt = tdt + 1
					newevent.pos[3] = tempdate
				else
					tempdate = tempdate*10
					tempdate = tempdate + numbercheckandreturn(x)
					tdt = tdt + 1
					newevent.pos[3] = tempdate
				end
			end
		end
	end
end