---- EXAMPLE OF HOW TO USE THIS TABLE
----
---- require "ow_rope.lua"
---- libraries = {"illusion.lua"}
---- ropeLoad("exampledirectory","examplesavefile")
----


function ropeLoad(directory,savefile)
	math.randomseed(os.time())	
	
	-- you can put all the libraries your game loads here
	
	love.filesystem.setIdentity(directory)
	-- >>>
	if love.filesystem.exists(savefile) then 
		ropeRead(savefile)
	elseif not love.filesystem.exists(savefile) then
	-- place what you want the default settings for this file here
		settings = {
			colour = {{255,255,255},{0,0,0}},
		}
		events = {
				{"Christmas","repeat",{25,12,2012}},
			}
		--use this bit to save in other ways
		eventsoutput = "events={"
		for i,v in ipairs(events) do
			eventsoutput = eventsoutput.."{"..'"'..v[1]..'"'..","..'"'..v[2]..'"'..","..ropeBurn(v[3]).."},"
		end
		eventsoutput = eventsoutput.."}"
		love.filesystem.write(savefile,"settings="..ropeBurn(settings)..eventsoutput)
	end
	
	-- <<<
	-- if you need more files copy and paste the stuff between >>> and <<<
	-- modify savefile and directory so they become savefile1 and directory1
	-- then add them to the box next to "ropeLoad" and where you call it in the love.load
end

-- tables must be compatible with ropeburn

function ropeBurn(t)
	local data = {}
	if type(t) == "number" then
		return t
	elseif type(t) == "boolean" then
		if t then
			return "true"
		elseif not t then
			return "false"
		end
	elseif type(t) == "string" then
		return t
	elseif type(t) == "table" then
		local data = {}
		table.insert(data,"{")
		for k,v in pairs(t) do
			if type(k) ~= "number" then
				local k_info = ropeBurn(k)
				local v_info = ropeBurn(v)
				table.insert(data,k_info)
				table.insert(data,"=")
				table.insert(data,v_info)
				table.insert(data,",")
			elseif type(k) == "number" and type(v) == "table" then
				local k_info = ropeBurn(k)
				local v_info = ropeBurn(v)
				table.insert(data,v_info)
				table.insert(data,",")
			elseif type(k) == "number" and type(v) == "number" then
				local k_info = ropeBurn(k)
				local v_info = ropeBurn(v)
				table.insert(data,v_info)
				table.insert(data,",")
			end
		end
		table.insert(data,"}")
		return table.concat(data)
	end
end

function ropeRead(item)
	love.filesystem.load(item)()
end